SystemOrganization addCategory: #'SBE-Quinto'!

Trait named: #TAuthor
	uses: {}
	category: 'SBE-Quinto'!

!TAuthor methodsFor: 'as yet unclassified' stamp: 'MK 4/29/2012 18:37'!
author
	"Returns author initials"
	^ 'on' "oscar nierstasz"! !

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'MK 4/29/2012 01:20' prior: 0!
Represents cell on game board!

!SBECell methodsFor: 'initialization' stamp: 'MK 4/29/2012 01:25'!
initialize
	"custom initialization"
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.
! !

!SBECell methodsFor: 'accessing' stamp: 'MK 4/29/2012 01:53'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'MK 4/29/2012 01:55'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	uses: TAuthor
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame commentStamp: 'MK 4/29/2012 01:30' prior: 0!
Represents game of Quinto!

SBEGame class
	uses: TAuthor classTrait
	instanceVariableNames: ''!

!SBEGame methodsFor: 'as yet unclassified' stamp: 'MK 4/29/2012 01:44'!
cellsPerSide
	"The number of cells along each side of the game"
	^ 10
! !

!SBEGame methodsFor: 'initialization' stamp: 'MK 4/29/2012 01:40'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j].! !

!SBEGame methodsFor: 'as yet unclassified' stamp: 'MK 4/29/2012 02:12'!
newCellAt: i at: j
	"Creates a cell for position (i, j) on a game board and adds it to my on-screen
	representatio at the appropriate screen position. Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c.
! !

!SBEGame methodsFor: 'game logic' stamp: 'MK 4/29/2012 01:51'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [(cells at: i - 1 at: j) toggleState].
	(i < self cellsPerSide) ifTrue: [(cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [(cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [(cells at: i at: j + 1) toggleState].
! !
